# Support for Feel++

Thank you for using and contributing to Feel++! Here are the ways you can get support:

## Table of Contents

- [How to Ask for Help](#how-to-ask-for-help)
- [Reporting Bugs](#reporting-bugs)
- [Feature Requests](#feature-requests)
- [Community and Discussion](#community-and-discussion)

## How to Ask for Help

If you need help with using Feel++ or have questions, you can:

1. **Check the Documentation**: Our [documentation](https://docs.feelpp.org) covers installation, usage, and advanced topics.
2. **Search the Issues**: Use the GitHub [issue tracker](https://github.com/feelpp/feelpp/issues) to see if someone else has already asked your question.

If you still need help, please [open a new issue](https://github.com/feelpp/feelpp/issues/new) and provide as much detail as possible. This includes:
- A clear description of your problem or question.
- Steps to reproduce the issue, if applicable.
- Any relevant logs or error messages.
- The version of Feel++ you are using.

## Reporting Bugs

If you encounter a bug, please report it by [opening an issue](https://github.com/feelpp/feelpp/issues/new). Make sure to include:
- A detailed description of the bug.
- Steps to reproduce the bug.
- Expected and actual behavior.
- Screenshots or logs, if applicable.
- Your environment details (e.g., OS, Feel++ version).

## Feature Requests

We welcome suggestions for new features! To request a feature, please [open a new issue](https://github.com/feelpp/feelpp/issues/new) and include:
- A clear description of the feature you would like to see.
- Why you believe this feature would be beneficial.
- Any examples or use cases.

## Community and Discussion

Join our community to discuss ideas, share solutions, and connect with other users and contributors:
- **GitHub Discussions**: Participate in discussions on our [GitHub Discussions page](https://github.com/feelpp/feelpp/discussions).
- **Slack**: Join our [Slack community](https://join.slack.com/t/feelpp/shared_invite/zt-2qe0q9hw-4pVbhohCXUE6Po9Ma8dbiQ) for real-time chat and support.

---

Thank you for your support and contributions!